VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "iDS345"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

'----------------------------------------------------------------------------------
'------- (C) 2006 W2Laboratories, www.w2lab.com                        ------------
'------- This software is provided as is                               ------------
'------- While all the programmed functionalities are tested,          ------------
'------- please verify them under your application conditions          ------------
'----------------------------------------------------------------------------------
'----------------------------------------------------------------------------------

'This is a class for SRS DS345 function generator.
'Only serial interface is provided

Private Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)

Public Enum DS345FunctionEnum
    DS345_Sine = 0
    DS345_Square = 1
    DS345_Triangle = 2
    DS345_Ramp = 3
    DS345_Noise = 4
    DS345_Arbitray = 5
End Enum

Private mPort As CWSerial
Private mName As String
Private mWaveType As Integer
Private mAmplitude As String
Private mFrequency As String

Public Function Initialize(ByRef cwCtrl As CWSerial, _
                           ByVal BoardNum_Or_ComPort As Integer, _
                           ByVal InstrAdrs_Or_BaudRate As Integer, _
                           Optional ByVal bRaiseError As Boolean) As Boolean
    Dim s$
    Dim sData$()
    
    On Error GoTo ErrHandler
    
    Set mPort = cwCtrl
    With mPort
        .ComPort = BoardNum_Or_ComPort
        .BaudRate = InstrAdrs_Or_BaudRate
        .Parity = cwParityNone
        .DataBits = cwDataBitsEight
        .StopBits = cwStopBitsTwo
        .DataAsString = True
        .FlowControl = cwFlowControlHW
        .TimeoutValue = 500
        .Configure
    
        'get ID
        .Write "*IDN?" + vbCr
        s = .Read
        sData = Split(s, ",")
        mName = sData(1)
    End With
    
    Initialize = True
    
ErrHandler:
    If bRaiseError And Err.Number <> 0 Then
        Err.Raise Err.Number, Err.Source, Err.Description, Err.HelpFile, Err.HelpContext
    End If
End Function

Public Property Let Amplitude_V(ByVal vData As Single)
    WriteCmd "AMPL" & vData & "VP"
End Property

Public Property Get Amplitude_V() As Single
    Amplitude_V = QueryData("AMPL?VP")
End Property

Public Property Let Frequency_Hz(ByVal vData As Single)
    WriteCmd "FREQ" & vData
End Property

Public Property Get Frequency_Hz() As Single
    Frequency_Hz = QueryData("FREQ?")
End Property

Public Property Let Offset_V(ByVal vData As Single)
    WriteCmd "OFFS" & vData
End Property

Public Property Get Offset_V() As Single
    Offset_V = QueryData("OFFS?")
End Property

Public Property Let WaveType(ByVal vData As DS345FunctionEnum)
    WriteCmd "FUNC" & vData
End Property

Public Property Get WaveType() As DS345FunctionEnum
    WaveType = QueryData("FUNC?")
End Property

'Public Sub SetWave(ByVal WaveType As DS345FunctionEnum, ByVal Frequency As Single, ByVal Amplitude As Single)
'    Dim sCmd$
'
'    sCmd = "FUNC" & WaveType
'    sCmd = sCmd & ";FREQ" & Frequency
'    sCmd = sCmd & ";AMPL" & Amplitude & "VP"
'
'    mPort.Write sCmd & vbCr
'End Sub
'
'Public Sub SaveSettings()
'    mWaveType = Me.WaveType
'    mFrequency = Me.Frequency
'    mAmplitude = Me.Vpp
'End Sub

'Public Sub RestoreSettings()
'    Me.SetWave mWaveType, mFrequency, mAmplitude
'End Sub

Private Sub WriteCmd(ByVal sCmd)
    mPort.Write sCmd + vbCr
End Sub

Private Function QueryData(ByVal sCmd As String) As Single
    Dim Value!
    Dim c%
    
    mPort.Write sCmd + vbCr
    sCmd = mPort.Read
    QueryData = Val(sCmd)


End Function

