VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "iJDSUSBSW"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

'----------------------------------------------------------------------------------
'------- (C) 2002-2004 W2Laboratories, www.w2lab.com                   ------------
'------- This software is provided as is                               ------------
'------- While all the programmed functionalities are tested,          ------------
'------- please verify them under your application conditions          ------------
'----------------------------------------------------------------------------------
'----------------------------------------------------------------------------------

'This is a class for JDSU SB Serial Optic Switches
'It has the same software interface as Agilent Optic Switches

Private Const MyName$ = "JDSU SB Serial Optic Switch"

Private mGPIB As CWGPIB
Private mModelName As String

Private mChFirst As Integer
Private mChLast As Integer

'initialize this class
Public Function Initialize(ByRef CWGPIB As CWGPIB, ByVal BoardNum As Integer, _
                           ByVal InstrAdrs As Integer, _
                           Optional ByVal bRaiseError As Boolean) As Boolean
    Dim s$, sData$()
    
    'first ini
    On Error GoTo ErrHandler
    Set mGPIB = CWGPIB
    With mGPIB
        .BoardNumber = BoardNum
        .PrimaryAddress = InstrAdrs
        .TimeoutValue = cwGPIBTimeoutT1s
        .Configure
        .Clear
        
        'get instrument type
        .Write "IDN?"
        s = .Read
        sData = Split(s, ",")
        mModelName = sData(1)
         
        Initialize = True
    End With
    
ErrHandler:
    If bRaiseError And Err.Number <> 0 Then
        Err.Raise Err.Number, Err.Source, Err.Description, Err.HelpFile, Err.HelpContext
    End If
End Function

Public Property Let ChOut(ByVal vData As Integer)
    Dim sCmd$
    
    sCmd = "CLOSE " & vData
    mGPIB.Write sCmd
End Property

Public Function Off()
    Me.ChOut = 0
End Function

Public Property Get ChOut() As Integer
    Dim s$
    
    s = QueryData("CLOSE?")
    ChOut = CInt(s)
End Property

Private Function QueryData(ByVal sCmd As String) As String
    mGPIB.Write sCmd
    sCmd = mGPIB.Read
    QueryData = Left(sCmd, Len(sCmd) - 1)
End Function


