VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "iVWRChiller"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit


'----------------------------------------------------------------------------------
'------- (C) 2002 W2Laboratories, www.w2lab.com                        ------------
'------- This software is provided as is                               ------------
'------- While all the programmed functionalities are tested,          ------------
'------- please verify them under your application conditions          ------------
'----------------------------------------------------------------------------------
'----------------------------------------------------------------------------------

'this is a class for VWR Chiller

Private Const MyName$ = "VWR Chiller"
Private Const MyError! = -999

Private mSerial As cwSerial

Public Function Initialize(ByRef cwSerial As cwSerial, _
                           Optional ByVal ComPort As Integer = 1, _
                           Optional ByVal BaudRate As Integer = 9600) As Boolean
    
    If cwSerial Is Nothing Then Exit Function
    
    On Error GoTo ErrHandler:
    
    Set mSerial = cwSerial
    
    With mSerial
        'comm protocal
        .ComPort = ComPort
        .BaudRate = BaudRate
        .parity = cwParityNone
        .DataBits = cwDataBitsEight
        .StopBits = cwStopBitsOne
        'others
        .DataAsString = True
        .TimeoutValue = 1000
        .EOSChar = vbCr
        .Configure
    End With
    
    Initialize = CheckConnection
    Exit Function
    
ErrHandler:
    MsgBox Err.Number & vbCrLf & Err.Description, vbCritical + vbOKOnly, MyName
End Function

Public Function CheckConnection() As Boolean
    Dim t!
    t = Me.ReadTemperature
    CheckConnection = (t <> MyError)
End Function


'set point
Public Property Let Setpoint(ByVal vData As Single)
    mSerial.Write "S " & vData & vbCrLf
End Property

Public Property Get Setpoint() As Single
    mSerial.Write "S?" & vbCrLf
    Setpoint = ReadData
End Property

'DisplayUnit
Public Property Let DisplayDegC(ByVal vData As Boolean)
    mSerial.Write "UC"
End Property

'read temperature
Public Function ReadTemperature() As Single
    mSerial.Write "F?" & vbCrLf
    ReadTemperature = ReadData
End Function

'start, stop
Public Sub StartChiller()
    mSerial.Write "ON" & vbCrLf
End Sub

Public Sub StopChiller()
    mSerial.Write "OFF" & vbCrLf
End Sub

Private Function ReadData() As Single
    Dim s$
    On Error Resume Next
    mSerial.ClearInputBuffer
    s = mSerial.Read
    s = Trim(s)
    s = Left(s, Len(s) - 1)
    If IsNumeric(s) Then
        ReadData = CSng(s)
    Else
        ReadData = MyError
    End If
End Function
