VERSION 5.00
Begin VB.UserControl svcSRLockin 
   ClientHeight    =   765
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   765
   InvisibleAtRuntime=   -1  'True
   Picture         =   "svcSRLockin.ctx":0000
   ScaleHeight     =   765
   ScaleWidth      =   765
   ToolboxBitmap   =   "svcSRLockin.ctx":030A
End
Attribute VB_Name = "svcSRLockin"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

'public enum
Public Enum lockinChannel
    ChannelX = 0
    ChannelY = 1
    ChannelR = 2
    ChannelPhase = 3
End Enum

Public Enum lockinDYNRES
    lockin20dB = 0
    lockin40dB = 1
    lockin60dB = 2
End Enum

Public Enum lockinLocalRemote
    ModeLocal = 0
    ModeRemote = 1
    ModeLockout = 2
End Enum

Public Enum lockinReferenceMode
    Reference_1f = 0
    Reference_2f = 1
End Enum

Public Enum lockinSensitivity
    Scale10nV = 1
    Scale20nV = 2
    Scale50nV = 3
    Scale100nV = 4
    Scale200nV = 5
    Scale500nV = 6
    Scale1uV = 7
    Scale2uV = 8
    Scale5uV = 9
    Scale10uV = 10
    Scale20uV = 11
    Scale50uV = 12
    Scale100uV = 13
    Scale200uV = 14
    Scale500uV = 15
    Scale1mV = 16
    Scale2mV = 17
    Scale5mV = 18
    Scale10mV = 19
    Scale20mV = 20
    Scale50mV = 21
    Scale100mV = 22
    Scale200mV = 23
    Scale500mV = 24
End Enum

Public Enum lockinTriggerMode
    PositiveTrigger = 0
    SymmetricTrigger = 1
    NegativeTrigger = 2
End Enum

Public Enum lockinDisplay
    DisplayXY = 0
    DisplayXYOffset = 1
    DisplayR = 2
    DisplayROffset = 3
    DisplayXYNoise = 4
    DisplayDAC = 5
End Enum

Public Enum lockinPreTimeConstant
    PreTime1ms = 1
    PreTime3ms = 2
    PreTime10ms = 3
    PreTime30ms = 4
    PreTime100ms = 5
    PreTime300ms = 6
    PreTime1s = 7
    PreTime3s = 8
    PreTime10s = 9
    PreTime30s = 10
    PreTime100s = 11
End Enum

Public Enum lockinPostTimeConstant
    PostTimeNone = 0
    PostTime100ms = 1
    PostTime1s = 2
End Enum

Dim m_Error As Boolean
Dim m_StatusByte As Integer
Dim m_havePreAmp As Boolean

'Default Property Values:
Const m_def_DeviceName = "SR Lock-in Amplifier"
Const m_def_BoardAddress = 0
Const m_def_DeviceAddress = 1

'Property Variables:
Dim m_DeviceName As String
Dim m_BoardAddress As Integer
Dim m_DeviceAddress As Integer

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=7,0,0,0
Public Property Get BoardAddress() As Integer
    BoardAddress = m_BoardAddress
End Property

Public Property Let BoardAddress(ByVal New_BoardAddress As Integer)
    m_BoardAddress = New_BoardAddress
    PropertyChanged "BoardAddress"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=7,0,0,1
Public Property Get DeviceAddress() As Integer
    DeviceAddress = m_DeviceAddress
End Property

Public Property Let DeviceAddress(ByVal New_DeviceAddress As Integer)
    m_DeviceAddress = New_DeviceAddress
    PropertyChanged "DeviceAddress"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=13,0,0,""
Public Property Get DeviceName() As String
    DeviceName = m_DeviceName
End Property

Public Property Let DeviceName(ByVal New_DeviceName As String)
    m_DeviceName = New_DeviceName
    PropertyChanged "DeviceName"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=0,0,2,0
Public Property Get EnableBandPassFilter() As Boolean
    If Ambient.UserMode = False Then Exit Property

    WriteCommand "B"
    EnableBandPassFilter = (GetValue = 1)
    
End Property

Public Property Let EnableBandPassFilter(ByVal New_EnableBandPassFilter As Boolean)
    If Ambient.UserMode = False Then Exit Property
    
    Dim cmd$
    cmd = "B" & IIf(New_EnableBandPassFilter, "1", "0")
    WriteCommand cmd
    
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=0,0,2,0
Public Property Get EnableNotchFilter() As Boolean
    If Ambient.UserMode = False Then Exit Property

    WriteCommand "L1"
    EnableNotchFilter = (GetValue = 1)
End Property

Public Property Let EnableNotchFilter(ByVal New_EnableNotchFilter As Boolean)
    If Ambient.UserMode = False Then Exit Property
    
    Dim cmd$
    cmd = "L1," & IIf(New_EnableNotchFilter, "1", "0")
    WriteCommand cmd
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=0,0,2,0
Public Property Get Enable2XNotchFilter() As Boolean
    If Ambient.UserMode = False Then Exit Property

    WriteCommand "L2"
    Enable2XNotchFilter = (GetValue = 1)
End Property

Public Property Let Enable2XNotchFilter(ByVal New_Enable2XNotchFilter As Boolean)
    If Ambient.UserMode = False Then Exit Property
    
    Dim cmd$
    cmd = "L2," & IIf(New_Enable2XNotchFilter, "1", "0")
    WriteCommand cmd
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=0,0,2,0
Public Property Get EnableXOffset() As Boolean
    If Ambient.UserMode = False Then Exit Property
    
    WriteCommand "OX"
    EnableXOffset = (GetValue = 1)
End Property

Public Property Let EnableXOffset(ByVal New_EnableXOffset As Boolean)
    If Ambient.UserMode = False Then Exit Property
    
    Dim cmd$
    cmd = "OX" & IIf(New_EnableXOffset, "1", "0")
    WriteCommand cmd
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=0,0,2,0
Public Property Get EnableYOffset() As Boolean
    If Ambient.UserMode = False Then Exit Property
    
    WriteCommand "OY"
    EnableYOffset = (GetValue = 1)
End Property

Public Property Let EnableYOffset(ByVal New_EnableYOffset As Boolean)
    If Ambient.UserMode = False Then Exit Property
    
    Dim cmd$
    cmd = "OY" & IIf(New_EnableYOffset, "1", "0")
    WriteCommand cmd
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=0,0,2,0
Public Property Get EnableROffset() As Boolean
    If Ambient.UserMode = False Then Exit Property
    
    WriteCommand "OR"
    EnableROffset = (GetValue = 1)
End Property

Public Property Let EnableROffset(ByVal New_EnableROffset As Boolean)
    If Ambient.UserMode = False Then Exit Property
    
    Dim cmd$
    cmd = "Or" & IIf(New_EnableROffset, "1", "0")
    WriteCommand cmd
End Property


'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=7,0,2,0
Public Property Get DynamicReserve() As lockinDYNRES
    If Ambient.UserMode = False Then Exit Property
    
    WriteCommand "D"
    DynamicReserve = GetValue
End Property

Public Property Let DynamicReserve(ByVal New_DynamicReserve As lockinDYNRES)
    If Ambient.UserMode = False Then Exit Property
    
    Dim Sensitivity%
    Dim min As lockinSensitivity, max As lockinSensitivity
    Const erMsg$ = "The selected dynamic reserve is not available." + vbCrLf
    'limit
    Select Case New_DynamicReserve
        Case lockin20dB
            min = Scale1uV
            max = Scale500mV
        Case lockin40dB
            min = Scale100nV
            max = Scale50mV
        Case lockin60dB
            min = Scale100nV
            max = Scale5mV
    End Select
    'check current sensitivity
    WriteCommand "G"
    Sensitivity = GetValue
    'raise error if out side limit
    If Sensitivity < min Then
        Err.Raise 9010, m_DeviceName, erMsg & "Please increase sensitivity scale."
    ElseIf Sensitivity > max Then
        Err.Raise 9011, m_DeviceName, erMsg & "Please reduce sensitivity scale."
    Else
        WriteCommand "D" & New_DynamicReserve
    End If
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=7,0,2,0
Public Property Get Sensitivity() As lockinSensitivity
    If Ambient.UserMode = False Then Exit Property
    
    WriteCommand "G"
    Sensitivity = GetValue
End Property

Public Property Let Sensitivity(ByVal New_Sensitivity As lockinSensitivity)
    If Ambient.UserMode = False Then Exit Property
    
    lSetScale New_Sensitivity

End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=7,0,2,0
Public Property Get TriggerMode() As lockinTriggerMode
    If Ambient.UserMode = False Then Exit Property
    
    WriteCommand "R"
    TriggerMode = GetValue
End Property

Public Property Let TriggerMode(ByVal New_TriggerMode As lockinTriggerMode)
    If Ambient.UserMode = False Then Exit Property
    WriteCommand "R" & New_TriggerMode
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=7,0,2,0
Public Property Get Display() As lockinDisplay
    If Ambient.UserMode = False Then Exit Property
    
    WriteCommand "S"
    Display = GetValue
End Property

Public Property Let Display(ByVal New_Display As lockinDisplay)
    If Ambient.UserMode = False Then Exit Property
    WriteCommand "S" & New_Display
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=7,0,2,0
Public Property Get PreTimeConstant() As lockinPreTimeConstant
    If Ambient.UserMode = False Then Exit Property
    
    WriteCommand "T1"
    PreTimeConstant = GetValue
End Property

Public Property Let PreTimeConstant(ByVal New_PreTimeConstant As lockinPreTimeConstant)
    If Ambient.UserMode = False Then Exit Property
    WriteCommand "T1," & New_PreTimeConstant
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=7,0,2,0
Public Property Get PostTimeConstant() As lockinPostTimeConstant
    If Ambient.UserMode = False Then Exit Property
    
    WriteCommand "T2"
    PostTimeConstant = GetValue
End Property

Public Property Let PostTimeConstant(ByVal New_PostTimeConstant As lockinPostTimeConstant)
    If Ambient.UserMode = False Then Exit Property
    WriteCommand "T2," & New_PostTimeConstant
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=0,0,2,False
Public Property Get havePreAmp() As Boolean
    If Ambient.UserMode = False Then Exit Property
    
    WriteCommand "H"
    m_havePreAmp = (GetValue = 1)
    havePreAmp = m_havePreAmp
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=7,0,2,0
Public Property Get RemoteStatus() As lockinLocalRemote
    If Ambient.UserMode = False Then Exit Property
    
    WriteCommand "I"
    RemoteStatus = GetValue
End Property

Public Property Let RemoteStatus(ByVal New_RemoteStatus As lockinLocalRemote)
    If Ambient.UserMode = False Then Exit Property
    WriteCommand "I" & New_RemoteStatus
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=7,0,2,0
Public Property Get ReferenceMode() As lockinReferenceMode
    If Ambient.UserMode = False Then Exit Property
    
    WriteCommand "M"
    ReferenceMode = GetValue
End Property

Public Property Let ReferenceMode(ByVal New_ReferenceMode As lockinReferenceMode)
    If Ambient.UserMode = False Then Exit Property
    WriteCommand "M" & New_ReferenceMode
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=0,0,2,False
Public Property Get ExpandChannel1() As Boolean
    If Ambient.UserMode = False Then Exit Property
    
    WriteCommand "E1"
    ExpandChannel1 = (GetValue = 1)
End Property

Public Property Let ExpandChannel1(ByVal New_ExpandChannel1 As Boolean)
    If Ambient.UserMode = False Then Exit Property
    
    Dim cmd$
    cmd = "E1," & IIf(New_ExpandChannel1, "1", "0")
    WriteCommand cmd
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=0,0,2,False
Public Property Get ExpandChannel2() As Boolean
    If Ambient.UserMode = False Then Exit Property
    
    WriteCommand "E2"
    ExpandChannel2 = (GetValue = 1)
End Property

Public Property Let ExpandChannel2(ByVal New_ExpandChannel2 As Boolean)
    If Ambient.UserMode = False Then Exit Property
    
    Dim cmd$
    cmd = "E2," & IIf(New_ExpandChannel2, "1", "0")
    WriteCommand cmd
    
End Property

'MemberInfo=0,0,2,False
Public Property Get ReferencePhaseShift() As Integer
    If Ambient.UserMode = False Then Exit Property
    
    WriteCommand "P"
    ReferencePhaseShift = (GetValue = 1)
End Property

Public Property Let ReferencePhaseShift(ByVal New_ReferencePhaseShift As Integer)
    If Ambient.UserMode = False Then Exit Property
    
    If New_ReferencePhaseShift > 999 Then
        New_ReferencePhaseShift = 999
    ElseIf New_ReferencePhaseShift < -999 Then
        New_ReferencePhaseShift = -999
    End If
    
    WriteCommand "P" & New_ReferencePhaseShift
End Property

Public Property Get Status() As String
    CheckStatus
    Status = ErrDesp
End Property

Public Property Get ReferenceFrequency() As Variant
    WriteCommand "F"
    ReferenceFrequency = GetValue
End Property

Public Sub Reset()
    WriteCommand "Z"
End Sub

Public Sub AutoOffset(ByVal channel As lockinChannel)
    Dim cmd$
    
    Select Case channel
        Case ChannelX:     cmd = "AX"
        Case ChannelY:     cmd = "AY"
        Case ChannelR:     cmd = "AR"
        Case ChannelPhase: cmd = "AP"
    End Select
    WriteCommand cmd

End Sub

Public Function ReadADC(ByVal channel As Integer) As Variant
    
    If channel < 1 Or channel > 4 Then _
        Err.Raise 9014, m_DeviceName, "Selected channel " & channel & " is not avaiable." & vbCrLf _
                                      & "Available ADC channels are 1, 2, 3, 4."
    
    WriteCommand "X" & channel
    ReadADC = GetValue
End Function

Public Function SendDAC(ByVal channel As Integer, ByVal value As Single) As Variant
    
    If channel < 5 Or channel > 6 Then _
        Err.Raise 9014, m_DeviceName, "Selected channel " & channel & " is not avaiable." & vbCrLf _
                                      & "Available ADC channels are 5, 6."
    
    If value < -10.238 Then
        value = -10.238
    ElseIf value > 10.238 Then
        value = 10.238
    End If
    
    WriteCommand "X" & channel & "," & value
    WriteCommand "X" & channel
    SendDAC = GetValue
    
End Function

Public Function Measure(ByVal MeasureType As lockinChannel, Optional ByVal Sensitivity As lockinSensitivity = 0) As Variant
    Dim oldCmd$, newCmd$, offsetCmd$, readCmd$
    Dim value As Variant
    Dim preDLY%, postDLY%, DLY%
    Const OVLD = 16
    Const NoOVLD = 0
        
    Select Case MeasureType
        Case ChannelX
            readCmd = "Q1"
            newCmd = "S0"
            offsetCmd = "S1"
        Case ChannelY
            readCmd = "Q2"
            newCmd = "S0"
            offsetCmd = "S1"
        Case ChannelR
            readCmd = "Q1"
            newCmd = "S2"
            offsetCmd = "S3"
        Case ChannelPhase
            readCmd = "Q2"
            newCmd = "S2"
            offsetCmd = ""
    End Select
    
    'auto scale if needed
    If Sensitivity <> 0 Then
        
        'find tiem constant
        WriteCommand "T2"
        Select Case GetValue
            Case 0:     postDLY = 0
            Case 1:     postDLY = 100
            Case 2:     postDLY = 1000
        End Select
        
        WriteCommand "T1"
        Select Case GetValue
            Case 1:     preDLY = 1
            Case 2:     preDLY = 3
            Case 3:     preDLY = 10
            Case 4:     preDLY = 30
            Case 5:     preDLY = 100
            Case 6:     preDLY = 300
            Case 7:     preDLY = 1000
            Case 8:     preDLY = 3000
            Case 9:     preDLY = 10000
            Case 10:    preDLY = 30000
            Case 11:    preDLY = 100000
        End Select
  
        DLY = IIf(preDLY > postDLY, preDLY, postDLY)
        If DLY < 1000 Then DLY = 800
        
        'set ini scale
        lSetScale Sensitivity
        DelayFor 100
        CheckStatus
        
        'decrease scale if not over load
        Do Until ((m_StatusByte And OVLD) = OVLD)
            Sensitivity = Sensitivity - 1
            lSetScale Sensitivity
            CheckStatus
            CheckStatus
        Loop
        'inclrease scale if overload
        Do Until ((m_StatusByte And OVLD) = 0)
            If Sensitivity > Scale500mV Then
                Err.Raise 9014, m_DeviceName, "Input overload"
            End If
            Sensitivity = Sensitivity + 1
            DelayFor DLY
            lSetScale Sensitivity
            CheckStatus
            CheckStatus
        Loop
    End If
    
    'svae current display mode
    WriteCommand "S"
    oldCmd = "S" & GetValue
    
    'select display
    DelayFor 500
    If oldCmd <> newCmd Then WriteCommand newCmd
    WriteCommand readCmd
    value = GetValue
    WriteCommand offsetCmd
    WriteCommand readCmd
    value = value - GetValue
    
    Measure = value
    
    'reset old display
    WriteCommand oldCmd
    
End Function

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=5
Public Sub Initialize()
    'DevClear m_BoardAddress, m_DeviceAddress
    Send m_BoardAddress, m_DeviceAddress, vbCrLf, DABend
    'if there RepAmp
    WriteCommand "H"
    m_havePreAmp = (GetValue = 1)
    
End Sub

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=5
Public Sub IEEEOut(ByVal cmd As String)
     WriteCommand cmd
End Sub


'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=14,3,1,0
Public Property Get ValueIn() As Variant
    ValueIn = GetValue
End Property

'Initialize Properties for User Control
Private Sub UserControl_InitProperties()
    m_BoardAddress = m_def_BoardAddress
    m_DeviceAddress = m_def_DeviceAddress
    m_DeviceName = m_def_DeviceName
End Sub

'Load property values from storage
Private Sub UserControl_ReadProperties(PropBag As PropertyBag)

    m_BoardAddress = PropBag.ReadProperty("BoardAddress", m_def_BoardAddress)
    m_DeviceAddress = PropBag.ReadProperty("DeviceAddress", m_def_DeviceAddress)
    m_DeviceName = PropBag.ReadProperty("DeviceName", m_def_DeviceName)
    
End Sub

Private Sub UserControl_Resize()
    Width = 480
    Height = 480
End Sub

'Write property values to storage
Private Sub UserControl_WriteProperties(PropBag As PropertyBag)

    Call PropBag.WriteProperty("BoardAddress", m_BoardAddress, m_def_BoardAddress)
    Call PropBag.WriteProperty("DeviceAddress", m_DeviceAddress, m_def_DeviceAddress)
    Call PropBag.WriteProperty("DeviceName", m_DeviceName, m_def_DeviceName)
    
End Sub

Private Sub WriteCommand(ByVal cmd As String)
    Send m_BoardAddress, m_DeviceAddress, cmd, DABend
    Do Until (ibsta And CMPL) Or (ibsta And EERR)
        DoEvents
        Debug.Print "HERE"
    Loop
    CheckError
    If m_Error Then Err.Raise 9001, "GPIB Error", ErrDesp
End Sub

Private Function GetValue() As Variant
    Dim p%
    Dim Data As String * 100
    
    GetValue = ""
    
    If Not m_Error Then
        Call Receive(m_BoardAddress, m_DeviceAddress, Data, STOPend)
        CheckError
        If Not m_Error Then
            p = InStr(Data, Chr(13))
            If p > 0 Then GetValue = Left(Data, p - 1)
        End If
    End If
    
    If m_Error Then Err.Raise 9001, "GPIB Error", ErrDesp
    
End Function

'Error handling
Private Sub CheckError()
    m_Error = GPIBError(m_DeviceName, m_BoardAddress, m_DeviceAddress)
End Sub

Private Sub CheckStatus()
    'somehow the serial poll is slow
    'Dim device%(0), results%(0)
    'device(0) = m_DeviceAddress
    'AllSpoll m_BoardAddress, device, results
    'm_StatusByte = results(0)
    
    WriteCommand "Y"
    m_StatusByte = GetValue
    If m_StatusByte = 0 Then Exit Sub
    
    m_Error = True
    ErrDesp = ""
    If (m_StatusByte And 2) Then ErrDesp = ErrDesp & "Command Parameter out of Range" & " "
    If (m_StatusByte And 4) Then ErrDesp = ErrDesp & "No reference input is detected" & " "
    If (m_StatusByte And 8) Then ErrDesp = ErrDesp & "No lockin" & " "
    If (m_StatusByte And 16) Then ErrDesp = ErrDesp & "Input overload" & " "
    If (m_StatusByte And 32) Then ErrDesp = ErrDesp & "Auto offset out of range" & " "
    'If (Status And 64) Then ErrDesp = ErrDesp & ""& " "
    If (m_StatusByte And 128) Then ErrDesp = ErrDesp & "Command Error" & " "
End Sub

Private Sub lSetScale(ByVal New_Sensitivity As Integer)

    'check if preamp is present
    If Not m_havePreAmp And New_Sensitivity < Scale100nV Then
        Err.Raise 9012, m_DeviceName, "Selection is not allowed without pre-amplifier."
    End If
    'prevent too high or too low scale
    If New_Sensitivity > Scale500mV Then
        New_Sensitivity = Scale500mV
    ElseIf New_Sensitivity < Scale10nV Then
        New_Sensitivity = Scale10nV
    End If
    'set scale
    WriteCommand "G" & New_Sensitivity
End Sub

Private Sub DelayFor(ByVal ms As Long)
    Dim Tf#
    
    Tf = Timer + ms / 1000
    Do Until Timer > Tf
        DoEvents
    Loop
    
End Sub

